// SPDX-License-Identifier: GPL-2.0-only

/*
 *  ZeroMAC security label library
 *
 *  Author:
 *      Peter Gabor Gyulay <peter.gabor.gyulay@zeromac.uk>
 *
 *  Copyright (C) 2015-2020 Peter Gabor Gyulay <peter.gabor.gyulay@zeromac.uk>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License version 2,
 *      as published by the Free Software Foundation.
 */



#ifndef LIBZMAC_LABEL_H
#define LIBZMAC_LABEL_H

#include <sys/dir.h> 
#include <sys/param.h>  
#include <stdio.h>  
#include <string.h>  
#include <unistd.h>  
#include <stdlib.h>  
#include <sys/stat.h>  
#include <dirent.h>  
#include <pwd.h>  
#include <grp.h>  
#include <time.h>  
#include <sys/types.h>
#include <sys/xattr.h>
#include <errno.h>

#define MAX_LABEL_LENGTH 16
#define MAX_STORAGE_LABEL_LENGTH 64000

// error code 1-2 reserved for the shell, 3-19 reserved for the user space utilities, 20-99 are reserved for kernel UI errors
#define ZMAC_ERROR_CANNOT_READ_LABEL		-12
#define ZMAC_ERROR_CANNOT_WRITE_LABEL		-13
#define ZMAC_ERROR_INVALID_LABEL_ON_FILE	-14
#define ZMAC_ERROR_SECLABEL_SIZE_EXCEEDED	-15
#define ZMAC_ERROR_SECLABEL_INVALID		-16
#define ZMAC_ERROR_CANNOT_DELETE_SECLABEL	-17
#define ZMAC_ERROR_INVALID_INPUT_LABEL		-18


#ifdef LIB_ZMAC_LABEL_INLINE
#define LIB_ZMAC_LABEL_NEED_INLINE inline // if compiled with lib included, you can choose to build inline the needed ones
#else // LIB_ZMAC_LABEL_INLINE
#define LIB_ZMAC_LABEL_NEED_INLINE // if compiled as library, functions will appear
#endif // LIB_ZMAC_LABEL_INLINE

#endif // LIBZMAC_LABEL_H