// SPDX-License-Identifier: GPL-2.0-only

/*
 *  ZeroMAC admin utlity
 *
 *  Author:
 *      Peter Gabor Gyulay <peter.gabor.gyulay@zeromac.uk>
 *
 *  Copyright (C) 2015-2020 Peter Gabor Gyulay <peter.gabor.gyulay@zeromac.uk>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License version 2,
 *      as published by the Free Software Foundation.
 */


#include "../lib/libzmac_console.c"

#define API_REQ "api 2.0\n"

int main(int argc, char **argv, char **env)
{  
	if (argc>1) 
	{
		int len,ret;
		register char *command;
		if (!(command=zmac_allocate_command_and_args(API_REQ "set admin",argc,argv,&len))) return zmac_return_shell_code(ZMAC_ERROR_OUT_OF_MEMORY);
		ret=zmac_run_console_command(command,len,ZMAC_PRINT_RESULT);
		memset(command,0,len);
		free(command);
		return zmac_return_shell_code(ret);
	}
	else
	{
		register char *command=API_REQ "show admin";
		return zmac_return_shell_code(zmac_run_console_command(command,strlen(command)+1,ZMAC_PRINT_CONTENT));
	}
} 

