// SPDX-License-Identifier: GPL-2.0-only

/*
 *  ZeroMAC console utility
 *
 *  Author:
 *      Peter Gabor Gyulay <peter.gabor.gyulay@zeromac.uk>
 *
 *  Copyright (C) 2015-2020 Peter Gabor Gyulay <peter.gabor.gyulay@zeromac.uk>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License version 2,
 *      as published by the Free Software Foundation.
 */
          
#include "../lib/libzmac_console.c"
#include "unistd.h"

#define API_REQ "api 2.0\n"

int main(int argc, char **argv, char **env)
{  
	if (argc>1) 
	{
		int len,ret;
		char *command;
		if (!(command=zmac_allocate_command_and_args(API_REQ,argc,argv,&len))) return zmac_return_shell_code(ZMAC_ERROR_OUT_OF_MEMORY);
		ret=zmac_console_submit_and_print_result_api(command,len,1,2,1);
		memset(command,0,len);
		free(command);
		return zmac_return_shell_code(ret);
	}
	if (isatty(0) && isatty(1)) fprintf(stderr,"ZeroMAC console v" VERSION " (c) 2015-2020 Peter Gabor Gyulay <peter.gabor.gyulay@zeromac.uk>\n");
	return zmac_return_shell_code(zmac_console_pipe(0,1));
} 


