// SPDX-License-Identifier: GPL-2.0-only

/*
 *  ZeroMAC security label change utility
 *
 *  Author:
 *      Peter Gabor Gyulay <peter.gabor.gyulay@zeromac.uk>
 *
 *  Copyright (C) 2015-2020 Peter Gabor Gyulay <peter.gabor.gyulay@zeromac.uk>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License version 2,
 *      as published by the Free Software Foundation.
 */


#define LIB_ZMAC_LABEL_INLINE // need some functions inline

#include "../lib/libzmac_label.c"


int main(int argc, char **argv, char **env)
{  
	char *reqa = NULL, *reqe = NULL, *reqc = NULL;
	register int c, error = 0;
	if (argc < 2) {fprintf (stderr, "ZeroMAC security fs label change utility v" VERSION " (c) 2015-2020 Peter Gabor Gyulay <peter@zeromac.uk>\nSyntax: %s access:exec:create filenames...\n", argv[0]); exit(1);}
	zmac_extractsingleblock(argv[1], &reqa, &reqe, &reqc); 
	if (!zmac_validlabel(reqa)) {fprintf (stderr, "invalid access label: %s\n", reqa); return zmac_return_shell_code(ZMAC_ERROR_INVALID_INPUT_LABEL);}
	if (!zmac_validlabel(reqe)) {fprintf (stderr, "invalid exec label: %s\n", reqe); return zmac_return_shell_code(ZMAC_ERROR_INVALID_INPUT_LABEL);}
	if (!zmac_validlabel(reqc)) {fprintf (stderr, "invalid create label: %s\n", reqc); return zmac_return_shell_code(ZMAC_ERROR_INVALID_INPUT_LABEL);}
	for (c = 2; !error && c < argc; c++) error=zmac_changelabel(argv[c], reqa, reqe, reqc);
	return zmac_return_shell_code(error);
} 


