// SPDX-License-Identifier: GPL-2.0-only

/*
 *  ZeroMAC rule utility
 *
 *  Author:
 *      Peter Gabor Gyulay <peter.gabor.gyulay@zeromac.uk>
 *
 *  Copyright (C) 2015-2020 Peter Gabor Gyulay <peter.gabor.gyulay@zeromac.uk>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License version 2,
 *      as published by the Free Software Foundation.
 */


#include "../lib/libzmac_console.c"

#define API_REQ "api 2.0\n"


int zmac_check_last_chars(char *string,char *check);


int main(int argc, char **argv, char **env)
{  
	if (argc>1) 
	{
		int len,ret;
		register char *command,*action;
		if (zmac_check_last_chars(argv[0],"mod")) action=API_REQ "mod rule";
		else if (zmac_check_last_chars(argv[0],"del")) action=API_REQ "del rule";
		else action=API_REQ "set rule";
		if (!(command=zmac_allocate_command_and_args(action,argc,argv,&len))) return zmac_return_shell_code(ZMAC_ERROR_OUT_OF_MEMORY);
		ret=zmac_run_console_command(command,len,ZMAC_PRINT_RESULT);
		memset(command,0,len);
		free(command);
		return zmac_return_shell_code(ret);
	}
	else
	{
		int ret;
		register char *command="show rules";
		ret=zmac_console_submit_and_print_result_api(command,strlen(command)+1,1,2,1);
		return zmac_return_shell_code(ret);
	}
} 

int zmac_check_last_chars(char *string,char *check)
{
	register int c,s;
	for (c=0;check[c];c++) {}
	for (s=0;string[s];s++) {}
	if (s<c) return 0;
	while (c) if (string[s--]!=check[c--]) return 0;
	return 1;
	
}
